/**
 *
 * @file UniqueListModel.qml
 * @brief ListModel with some basic functions
 *
 *
 * @copyright
 * Copyright 2002-2020, telerob G.f.F. mbH   ALL RIGHTS RESERVED
 * This computer program is the property of telerob Gesellschaft fuer
 * Fernhantierungstechnik mbH, Ostfildern, Germany, and may not be copied
 * in any form or by any means, whether in part or in whole, except under
 * license expressly granted by telerob GmbH.
 *
 * All copies of this program, whether in part or in whole, and whether
 * modified or not, must display this and all other embedded copyright
 * and ownership notices in full.
 *
 * @author Florian Otto
 * @date 14.09.2020
 * @ingroup TUI
 */

import QtQuick 2.12
import QtQml.Models 2.12


DelegateModel {
    id: delegateModel

    model: ListModel {
        id: ulModel
        Component.onCompleted: {
            for (let idx = 0; idx < 50; idx++) {
                ulModel.append({"filename" : idx + ".avi"})
            }
        }
    }

    groups: [
        DelegateModelGroup {
            includeByDefault: false
            name: "selected"
        }
    ]

    function getSelected(crash) {
        console.log("\tUniqueDelegateModel.qml getSelected()")
        var retList = []
        for (let i = 0; i < items.count; ++i) {
            var item = items.get(i)
            if(!crash) {
                for(let b = 0; b < item.groups.length; b++) {
                    if (item.groups[b] === "selected") {
                        retList.push(ulModel.get(i))
                    }
                }
            } else {
                for (let el of item.groups) {
                    if (el === "selected") {
                        retList.push(ulModel.get(i))
                    }
                }
            }
        }
        return retList
    }

    function selectAll(bSelect, crash) {
        console.log("UniqueDelegateModel.qml selectAll(select)", "select="+bSelect)
        for (let i = 0; i < items.count; ++i) {
            if(bSelect && !items.get(i).inSelected) {
                console.log("\tadding group for item", i)
                items.addGroups(i, 1, ["selected"])
            } else {
                console.log("\tremoving group for item", i)
                items.removeGroups(i, 1, ["selected"])
            }
            let temp = delegateModel.getSelected(crash)

        }
    }
}
