import QtQuick 2.15
import QtQuick.Window 2.15
import QtQuick.Controls 2.15
import QtQuick.Layouts 1.12
import QtQml.Models 2.15

Window {
    width: 640
    height: 480
    visible: true
    title: qsTr("Hello World")

    color: "brown"

    Component {
        id: fileDelegate
        Rectangle {
            id: item
            width: lvFiles.width
            height: 20
            color: item.DelegateModel.inSelected ? "white" : "transparent"

            Label {
                color: item.DelegateModel.inSelected ? "blue": "white"
                text: filename
            }
        }
    }

    ColumnLayout {
        id: colInt

        CheckBox {
            id: crashBox
            text: "Check this to enable crashing."
        }

        Item {
            id: listInt

            Layout.fillWidth: true
            Layout.preferredHeight: 250

            property alias fileModel: filesModel.model

            UniqueDelegateModel {
                id: filesModel
                delegate: fileDelegate
            }

            ListView {
                id: lvFiles
                anchors.fill: parent
                clip: true
                model: filesModel
            }
        }

        Button {
            id: btnIntFiles
            property bool bSelect: true
            text: "Toggle selection"
            onClicked:  {
                filesModel.selectAll(btnIntFiles.bSelect, crashBox.checked)
                bSelect = !bSelect
            }
        }
    }
}
